function openDialog(message, title)
{
  messenger.windows.create({
    height: 200,
    width: 325,
    url: "dlg.html?title=" + encodeURIComponent(title)
      + "&message=" + encodeURIComponent(message),
    type: "popup"
  });
}

messenger.menus.onShown.addListener(async function(menuinfo, tab) {
  await messenger.menus.removeAll();
  if (menuinfo.selectedMessages && menuinfo.selectedMessages.messages && menuinfo.selectedMessages.messages.length) {
    await messenger.menus.create({
      title: "GetRaw Exception Reproduction",
      contexts: ["all"],
      onclick: async (onclickinfo) => {
        for (let i = 0;i < menuinfo.selectedMessages.messages.length; i++) {
          try {
            let eml = await messenger.messages.getRaw(menuinfo.selectedMessages.messages[i].id);
            console.log("eml", eml);
            openDialog("getRaw succeeded, length: " + eml.length, "Success");
          } catch (e) {
            console.log(e);
            openDialog(e.toString(), "Error");
          }
        }
      }
    });
  }
  messenger.menus.refresh();
});
